"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.middyAdaptor = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("./logger");
var CallbackListener_1 = require("./CallbackListener/CallbackListener");
var MiddyMiddleware_1 = require("./MiddyMiddleware/MiddyMiddleware");
exports.middyAdaptor = function (middyMiddlewareObject) { return function (handler) { return function (event, context) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var callbackListener, instance, middyMiddleware, _a, error_1, newError;
    return tslib_1.__generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                callbackListener = new CallbackListener_1.CallbackListener();
                instance = {
                    context: tslib_1.__assign({}, context),
                    event: tslib_1.__assign({}, event),
                    response: null,
                    error: null,
                    callback: callbackListener.callback,
                };
                middyMiddleware = new MiddyMiddleware_1.MiddyMiddleware(middyMiddlewareObject);
                _b.label = 1;
            case 1:
                _b.trys.push([1, 5, , 7]);
                return [4 /*yield*/, middyMiddleware.before(instance)];
            case 2:
                _b.sent();
                if (callbackListener.callbackCalled) {
                    return [2 /*return*/, callbackListener.handleCallback()];
                }
                logger_1.logger("Calling handler");
                _a = instance;
                return [4 /*yield*/, handler(instance.event, context)];
            case 3:
                _a.response = _b.sent();
                logger_1.logger("handler ran successfully");
                return [4 /*yield*/, middyMiddleware.after(instance)];
            case 4:
                _b.sent();
                return [3 /*break*/, 7];
            case 5:
                error_1 = _b.sent();
                logger_1.logger("error in handler or before or after middleware");
                instance.error = error_1;
                return [4 /*yield*/, middyMiddleware.onError(instance, error_1)];
            case 6:
                newError = _b.sent();
                if (newError) {
                    throw newError;
                }
                return [3 /*break*/, 7];
            case 7:
                if (callbackListener.callbackCalled) {
                    return [2 /*return*/, callbackListener.handleCallback()];
                }
                logger_1.logger("returning response");
                return [2 /*return*/, instance.response];
        }
    });
}); }; }; };
//# sourceMappingURL=middy-adaptor.js.map